/****************************************************************/
/*  
     ***   ***  ***  *** ***     *** ***   ******  ****  ***
     ***   ***  ***  *** ***     *** **   ***  *** ***** ***
     ***   ***  ***  *** ***     *****    ******** *** *****
      *** ***   ***  *** ******* *** **   ***  *** ***  ****
       *****     *****   ******* *** ***  ***  *** ***   ***
	   
	 Vulkan Graphics API: in 20 Minutes (Coffee Break Series)
	 Beginners Taste

     Minimalistic examples to build upon and experiment with 
	 to develop an understanding of the underlying API

	   
/*
/****************************************************************/


// Vertex Shader
// shader version
#version 420

// input matrix transforms (3D) passed in 
// from our program
layout ( std140, set = 0, binding = 0 ) uniform buffer 
{
  mat4 projection_matrix;
  mat4 view_matrix;
  mat4 model_matrix;
} UBO;

// input a position and a colour
layout( location = 0 ) in vec4 pos;
layout( location = 1 ) in vec3 color;
layout( location = 2 ) in vec2 texCoords;

// output a color
layout( location = 0 ) out vec4 outColor;
layout( location = 1 ) out vec2 outTexCoords;



// shader entry point
void main() 
{	
  // combine the matrices
  mat4 modelView = UBO.model_matrix * UBO.view_matrix;

  // transform position by matrices
  gl_Position = pos * ( modelView * UBO.projection_matrix );

  // pass input colour to the next stage
  outColor = vec4(color, 1.0);
  // Or a fixed test color (RED)
  // OUT.vColor = vec4( 1.0, 0.0, 0.0, 1 );

  // pass input texture coordinates onto the fragment shader
  outTexCoords = texCoords;

}// End main(..)